package shadersmod.transform;

import java.util.Iterator;

import org.objectweb.asm.ClassReader;
import org.objectweb.asm.ClassVisitor;
import org.objectweb.asm.ClassWriter;
import org.objectweb.asm.FieldVisitor;
import org.objectweb.asm.Label;
import org.objectweb.asm.MethodVisitor;
import org.objectweb.asm.Opcodes;
import static org.objectweb.asm.Opcodes.*;

import org.objectweb.asm.commons.Remapper;
import org.objectweb.asm.tree.MethodNode;

import shadersmod.common.SMCLog;


import net.minecraft.launchwrapper.IClassTransformer;

// for DefaultVertexFormats

public class SMCCTDefVertexFormat implements IClassTransformer {

	@Override
	public byte[] transform(String par1, String par2, byte[] par3) {
		SMCLog.fine("transforming %s %s",par1,par2);
		ClassReader cr = new ClassReader(par3);
		ClassWriter cw = new ClassWriter(cr, 0);
		CVTransform cv = new CVTransform(cw);
		cr.accept(cv,0);
		return cw.toByteArray();
	}

	private static class CVTransform extends ClassVisitor
	{
		String classname;
		boolean endFields = false;
		
		public CVTransform(ClassVisitor cv)
		{
			super(Opcodes.ASM4, cv);		
		}

		@Override
		public void visit(int version, int access, String name,
				String signature, String superName, String[] interfaces) {
			classname = name;
			//SMCLog.info(" class %s",name);
			cv.visit(version, access, name, signature, superName, interfaces);
		}

		@Override
		public MethodVisitor visitMethod(int access, String name, String desc,
				String signature, String[] exceptions) {
			if (name.equals("<clinit>") && desc.equals("()V")) {
				MethodVisitor mv;
				mv = cv.visitMethod(ACC_STATIC, "<clinit>", "()V", null, null);
				mv.visitCode();
				mv.visitMethodInsn(INVOKESTATIC, "shadersmod/client/SVertexFormat", "makeDefVertexFormatBlock", "()"+Names.vertexFormat_.desc);
				mv.visitFieldInsn(PUTSTATIC, Names.defVertexFormat_block.clasName, Names.defVertexFormat_block.name, Names.defVertexFormat_block.desc);
				mv.visitMethodInsn(INVOKESTATIC, "shadersmod/client/SVertexFormat", "makeDefVertexFormatItem", "()"+Names.vertexFormat_.desc);
				mv.visitFieldInsn(PUTSTATIC, Names.defVertexFormat_item.clasName, Names.defVertexFormat_item.name, Names.defVertexFormat_item.desc);
				mv.visitInsn(RETURN);
				mv.visitMaxs(1, 0);
				mv.visitEnd();
				return null;
			}
			return cv.visitMethod(access, name, desc, signature, exceptions);
		}
	}
}
